CureFit Interview Experience | Software Engineer | Bangalore

แชร์
ฝัง
  • เผยแพร่เมื่อ 20 ม.ค. 2025

ความคิดเห็น • 110

  • @RachitJain
    @RachitJain  5 ปีที่แล้ว +37

    Check algoexpert.io/rachit and dailycodingproblem.com/rachit for Interview Prep.
    Hint for the Balloon Problem: You can mark balloon of height X as not important if there exists a balloon of height X+1 in its left side. Once you do that for all balloons, answer is nothing but the number of important balloons. Ofcourse, you need to take care of cases like [5,4,4]. The last balloon has a balloon on its left side with height 4+1, but still you need a separate arrow for that. Do this without worrying over time complexity. Get a working solution first, and then think of optimising this to O(N) time.

    • @jain007neeraj
      @jain007neeraj 5 ปีที่แล้ว

      Will the height of the arrow only decrease once we hit the balloon, or the arrow goes down in trajectory consistently.
      For Example in your example of [5,4,4,3,3] if we assume to decrease the height of the arrow only when it hits the balloon, then the minimum no of arrow needed is 2, but if we decrease arrow height consistently by 1 then we need 3 arrows, 1st time: 5, 4 and 2nd time: 4,3 and 3rd time : 3. So which one is valid, seems like Arrow has some special powers.

    • @RachitJain
      @RachitJain  5 ปีที่แล้ว

      Only after it hits a balloon.

    • @jain007neeraj
      @jain007neeraj 5 ปีที่แล้ว

      ​@@RachitJain Thanks for the clarification, but then according to your hint, how come the answer is 2 it should be 3.
      [5 , 4 , 4 , 3 , 3] ---> 5 is important since it has no greater element (5+1) on the left side, 4 is marked as non-important, 4 immediate left is not X+1 so this is important, the same case with 3 and 3. So total important balloons are 3 [5, 4, 3].

    • @RachitJain
      @RachitJain  5 ปีที่แล้ว +4

      Please dont confuse others as well. The balloon at index 1 and index 3 are important. I just gave a hint in the pinned comment. Use pen, paper and time to figure this out.

    • @jain007neeraj
      @jain007neeraj 5 ปีที่แล้ว +1

      Yeah, I did that and totally agree that index 1 and index 3 are important, could you please just give me another hint as to why *index 5 is not important*. (Assuming indexing of array is from 1 not 0).

  • @ethicalcoder8205
    @ethicalcoder8205 5 ปีที่แล้ว +34

    Did someone notice how beautifully he gave feedback to interviewers about coming late to interviews? I love how he is so honest and yet respectful at the same time. I used to screw things up when something wrong happened, or lose my temper. Respect to you, Rachit! You are doing amazing.

  • @Cru5ader
    @Cru5ader 5 ปีที่แล้ว +64

    Nice Video!! Please share your Tower Research and Goldman Sachs interview experience!!

  • @avonray9147
    @avonray9147 3 ปีที่แล้ว +2

    Will the balloon problem work with something like an unordered_multiset? Idea is, the leftmost balloon has to be shot directly, no other choice but to shoot a new arrow towards it. During this process, on visiting each ballon, we store the next value that we are expecting to see in the multiset. Also on visiting every new balloon, we check if there's any existing arrow that was waiting to hit it.
    On reaching 5, set is empty, so we increment arrow_count to 1, and add 5 - 1 = 4 to the set (since, the next expected value for current arrow is 4). On reaching the next 4, we find a 4 already in set, so that indicates that an existing arrow can hit 4.. we erase that 4 from set, and insert 4 - 1 = 3 (indicates that the arrow already hit it, and is now waiting for the next balloon). On reaching the next 4, we check for 4 in the set but don't find any (there's only one 3 present in set), hence we again increment arrow_count to 2. We also insert another 4 - 1 = 3 into the set, marking the current balloon hit. Currently set contains {3,3} which is why multiset was needed.
    This process continues. Final arrow_count is the answer. Works in O(N)
    (We could also use unordered_map with value as frequency to achieve the same thing as this).

  • @shroud3354
    @shroud3354 5 ปีที่แล้ว +22

    Please start a series on dynamic programming from beginner level..I know u have a dp playlist but thats for someone who's has already achieved a level..so pls make something for beginners as well

  • @JhaAdarsh
    @JhaAdarsh 5 ปีที่แล้ว +30

    Interview experience of tower research & Goldman Sachs

  • @kuldeeppilaji
    @kuldeeppilaji 5 ปีที่แล้ว +5

    You are Amazing Rachit! I always learn from your video, Gbu!

  • @akakop
    @akakop 5 ปีที่แล้ว +18

    which technologies u have worked on in Microsoft?

  • @aqib829
    @aqib829 5 ปีที่แล้ว +10

    According to you what could be the probable rating ( Codeforces Scale) of the problems who were asked in this interview?

  • @s_rox5042
    @s_rox5042 3 ปีที่แล้ว

    I think the solution is :
    We will keep a set which indicate the y-cordinate of fired arrows, and we decrement the fired coordinate value.
    For ex : 4 3 2 1 4
    init : set -> val i = 0, set.remove(4) set.add(val--) i = 1,....at i = 3 set has 1(yco) only,the last ele =4 check the set for val+1 i.e 5:since not present new arrow will be fired. Total arrows is total size of set
    Set set = new HashSet();
    for(int num : nums) {
    if(set.contains(num+1)) {
    set.remove(num+1);
    set.add(num);
    } else {
    set.add(num);
    }
    }
    return set.size();
    Correct me if am wrong.

  • @divyanshushukla6274
    @divyanshushukla6274 5 ปีที่แล้ว +4

    You motivate a lot, sir! ❤️

  • @sudarshanbaliga8957
    @sudarshanbaliga8957 5 ปีที่แล้ว +1

    My O(N) solution for baloon problem(considering b[i] >= b[i + 1]):
    Create two variable maxBaloon = 0 , currentLen = 1
    For every ith element check if i + 1 th element is same as i :
    if same as ith:
    increment the currenLen by 1
    else:
    maxBaloon = max(maxBaloon, currentLen)
    curLen = 1
    answer is maxBaloon

    • @shashanktp7572
      @shashanktp7572 4 ปีที่แล้ว

      if possible may I know the purpose of currentLen, instead increment the max ballon itself...

  • @damaharitejachowdary5117
    @damaharitejachowdary5117 5 ปีที่แล้ว +17

    Can you prepare a series on interview preparation

  • @krishnenduchakraborty4183
    @krishnenduchakraborty4183 5 ปีที่แล้ว +12

    Please share your interview experience with Goldman Sachs and Tower research capital!!!! Thanks🙏🙏🙏

  • @satyasaiteja8903
    @satyasaiteja8903 5 ปีที่แล้ว +4

    y did u leave microsoft? please share goldmansachs experience

  • @Rahulmishra-iv9dt
    @Rahulmishra-iv9dt 5 ปีที่แล้ว +4

    Best course for Android app development

  • @RahulYadav-sy3yf
    @RahulYadav-sy3yf 4 ปีที่แล้ว

    Hi , I have been working in startup from beginning of my career .The main problem I faced or facing is nobody talks about scalability or how to do things in a better way.

  • @sunilsigar3145
    @sunilsigar3145 5 ปีที่แล้ว

    Thanks for sharing you valuable experience

  • @kartiknighania8588
    @kartiknighania8588 5 ปีที่แล้ว

    Waiting for the answer..
    Thanks man ! The cool thing is the videos are short .. so rather than downloading or to add to watch later and then never watch it.. liked it this way... Also the new inteo splash is good.. good have been with figures as well.. like linusTechTips

  • @kushalvijay8056
    @kushalvijay8056 5 ปีที่แล้ว +4

    Tips/Tricks regarding preparation for the internship hiring process.

  • @MrPrathamesh160
    @MrPrathamesh160 5 ปีที่แล้ว +4

    Tower Research Capital, next one please!

  • @RandomPerson-hj8fq
    @RandomPerson-hj8fq 5 ปีที่แล้ว +3

    Sir, what do startups focus on your skills or data structures in technical interviews and if it depends on the type of startup you are going for.............Also whether your skillset affect your post in the company.

  • @harshpatel1385
    @harshpatel1385 5 ปีที่แล้ว

    awesome man!

  • @suvadeepmajumdar7804
    @suvadeepmajumdar7804 4 ปีที่แล้ว

    Can be done with O(n) even if not sorted by maintening two arrays

  • @whatsmyname9742
    @whatsmyname9742 5 ปีที่แล้ว +2

    please make a video on how to apply for software Engineer job. like in this case how did you approach the company for interview.

  • @Kevin-cy2dr
    @Kevin-cy2dr 4 ปีที่แล้ว

    Can you migrate to USA or any other counties from google, microsoft, amazon? Do they have any programs like that?

  • @dhirajbatra7495
    @dhirajbatra7495 5 ปีที่แล้ว +1

    Which middle man agency did you contact?

  • @RonaldoCR-fi9nk
    @RonaldoCR-fi9nk 3 ปีที่แล้ว

    Could you please tell us how much was offered to the IIT juniors so that we can have an idea. I know there are websites like Glassdoor for that but still it would be helpful.

  • @vigneshsekar2001
    @vigneshsekar2001 5 ปีที่แล้ว +2

    Bro what all the interviewer expect from the non-cse candidates other than data structures and algorithms.(I mean the subjects like os ,system design etc.)

  • @supriyamitra
    @supriyamitra 5 ปีที่แล้ว

    What is the name of consultancy and from where you are getting calls,like Naukri,monster etc... fir product based companies

  • @pratiksinha5737
    @pratiksinha5737 5 ปีที่แล้ว +1

    it would be quite helpful if you could share most of the questions asked in all the interview rounds

  • @devbhatia7107
    @devbhatia7107 5 ปีที่แล้ว

    How do i get job at big product based companies , i'm not from any IIT, NIT, etc . I am from tier 5 college. How?

  • @anuragmakade4486
    @anuragmakade4486 5 ปีที่แล้ว

    Cool intro!

  • @anubhavgupta2224
    @anubhavgupta2224 4 ปีที่แล้ว

    Does nearest smaller to the right approach work for this one ?

  • @SaurabhSingh-ch6nc
    @SaurabhSingh-ch6nc 5 ปีที่แล้ว

    Love it

  • @harshilmalawat
    @harshilmalawat 5 ปีที่แล้ว

    I also have developed solution in O(N) time.. Would like to compare and discuss whether its completely correct or having edge case issues

  • @jain007neeraj
    @jain007neeraj 5 ปีที่แล้ว +1

    How did you approach to this problem, please share that experience.

    • @RachitJain
      @RachitJain  5 ปีที่แล้ว

      Check pinned comment for the hint.

    • @jain007neeraj
      @jain007neeraj 5 ปีที่แล้ว

      @@RachitJain where is that.

    • @jain007neeraj
      @jain007neeraj 5 ปีที่แล้ว

      @@naimish_singh Thanks it was not visible when I posted the comment.

  • @umangmalhotra1222
    @umangmalhotra1222 5 ปีที่แล้ว

    Please share your work experience at Microsoft

  • @TechRack
    @TechRack 4 ปีที่แล้ว +2

    Do you know what is the scariest thing on a coding interview?😂

  • @devkantthefullstackguy
    @devkantthefullstackguy 5 ปีที่แล้ว +5

    @Rachit Jain ....That question is very interesting...I solved it(Language:-Java) but the time complexity is O(n^2)...
    Rachit bhaiya is there any way to solve it with O(n) time complexity

    • @piyushpathak1186
      @piyushpathak1186 3 ปีที่แล้ว

      I don't know if it will work for all test cases
      also one question will the arrow direction will be left to right or we can shoot it from right to left also
      int vis[n] = {0};
      int ans1 = 0;
      //caculating count from left to right
      for(int i=0;i

  • @shasha6538
    @shasha6538 5 ปีที่แล้ว

    What about ML and AI? Should I invest my time in learning new things ?

  • @arpit35007
    @arpit35007 5 ปีที่แล้ว

    Please also share numbers that they were offering, it would help people negotiate better.

  • @KZ-po8wc
    @KZ-po8wc 5 ปีที่แล้ว

    What is middle man actually can you elaborate??

  • @harshgupta4563
    @harshgupta4563 5 ปีที่แล้ว

    Hello bhaiya, like my college is starting in July my doubt is that how can I start with competitive programming like i learn c++ then what to do next to start with competitive programmin can you make a video in this topic not me many are waiting for this video

  • @Sanjiban5
    @Sanjiban5 4 ปีที่แล้ว

    no design round? wth!

  • @prodoshcmitter1120
    @prodoshcmitter1120 5 ปีที่แล้ว

    Sir is the app Codebook written by you???

  • @sangeetsingh2489
    @sangeetsingh2489 5 ปีที่แล้ว

    Can you suggest some good recruiting consultancies?

  • @namansanghi995
    @namansanghi995 5 ปีที่แล้ว +1

    What is the solution of that ques.....

    • @RachitJain
      @RachitJain  5 ปีที่แล้ว

      Check pinned comment.

    • @praveenkb4943
      @praveenkb4943 5 ปีที่แล้ว

      @@RachitJain There is no pinned comment!!

  • @vinaysinghal3877
    @vinaysinghal3877 5 ปีที่แล้ว +1

    Bhaiya How many language one should know(programming languages)

    • @RachitJain
      @RachitJain  5 ปีที่แล้ว +1

      One is enough. Focus on learning one on great depth. Then once you are stable and have time, you may explore others.

    • @samarthtandon2163
      @samarthtandon2163 5 ปีที่แล้ว

      Never judge anybody by no of languages he/she know.... The knowledge of DSA matters the most not the no of languages...... As I know more than 5 programming language but its just a waste if I don't be able to solve some problem with that....

  • @tanmaymishra3639
    @tanmaymishra3639 5 ปีที่แล้ว

    Hi Rachit can you please make a video of some good startups a fresher should consider joining.

  • @jeetupal
    @jeetupal 5 ปีที่แล้ว

    very cool

  • @romokdas8494
    @romokdas8494 5 ปีที่แล้ว

    Can you please give the solution of the balloon question?

  • @hariharankm3401
    @hariharankm3401 5 ปีที่แล้ว

    Would you recommend JavaScript for someone beginning with competitive programming or is looking to be in Front end zone.

    • @yashchachad
      @yashchachad 5 ปีที่แล้ว +2

      Never JavaScript is not recommended for competitive programming. Use CPP instead for competitive programming

    • @habeeb196
      @habeeb196 5 ปีที่แล้ว

      You can switch to python easily , it is kinda similar to JS

  • @parthlathiya5532
    @parthlathiya5532 5 ปีที่แล้ว +1

    Even I was asked same baloon question in interview at curefit. 😀 Not expecting from atleast curefit interviewer

  • @shubhamgoyal3100
    @shubhamgoyal3100 5 ปีที่แล้ว

    Was there any system design interview round, as you were applying for SDE-II positions?

  • @pavanagarwal6753
    @pavanagarwal6753 5 ปีที่แล้ว

    lovely how u show the problems from interview

  • @sahil6567
    @sahil6567 5 ปีที่แล้ว +1

    Hello Rachit. I recently got selected for mtech in iit roorkee cs. I'm a bit confused what should I focus in masters. Placements or research. I've heard that research in iitr is not up to the mark. Should I start competitive coding then and focus on placements?

    • @rajnikantyadav1315
      @rajnikantyadav1315 5 ปีที่แล้ว +1

      yes , buddy you should start competitive programming as soon as possible and devote atleast 7 hour for competitive programming for becoming best in the market and have keen focused on placements and internships start giving internships and also start studing system design competitive programming plus system design

  • @harjotsingh7735
    @harjotsingh7735 2 ปีที่แล้ว +1

    // Code for the Given problem in Java
    // Covering all edge cases
    public static int minArrows(int[] arr){
    int ans = 0;
    Map map = new HashMap(); // Number of arrows at that height
    for(int i = 0; i < arr.length; i++){
    int x = arr[i];
    if(map.containsKey(x) && map.get(x) > 0){
    map.put(x,map.get(x)-1); // Number of arrow decreased at current level
    map.put(x-1,map.getOrDefault(x-1,0)+1); // Number of arrows increased at lower level
    }
    else{
    ans++; // we need one more arrow
    map.put(x-1,map.getOrDefault(x-1,0)+1); // Number of arrows increased at lower level
    }
    }
    return ans;
    }

  • @rahulvats9086
    @rahulvats9086 5 ปีที่แล้ว +3

    Iit roorkee or iit guwahati.
    Which one is better for cse ?

  • @msr_atpeace
    @msr_atpeace 5 ปีที่แล้ว

    Please make a video for the explanation of manachers algorithm.

  • @devbhatia7107
    @devbhatia7107 4 ปีที่แล้ว

    Salary?

  • @ambarishkapil8004
    @ambarishkapil8004 5 ปีที่แล้ว

    Hello Rachit bhaiya, thankyou for making such interesting and informative videos.We appreciate your content a lot.
    I had a question that i hope you would elaborate upon. I am in my final year of my B.Tech course and want to apply for jobs.
    I am checking the careers website of the companies that i want to apply for, but there seems to be no open entry level positions in India, however there are many such open positions in Canada, Russia...etc. So my question is can i apply for the position in a foreign location and what would be the process for that. Thankyou.

  • @prodoshcmitter1120
    @prodoshcmitter1120 5 ปีที่แล้ว +1

    Sir plz make some videos on Google interview codings plz plz

  • @VikramKumar-wd4dr
    @VikramKumar-wd4dr 5 ปีที่แล้ว

    make a video of tower research

  • @pulkitgoel7406
    @pulkitgoel7406 5 ปีที่แล้ว +2

    Bhai humne bhi tumhare chakkar mei chod diya tha process.

    • @RachitJain
      @RachitJain  5 ปีที่แล้ว +1

      London Thumakda!

  • @nirajshaw5730
    @nirajshaw5730 5 ปีที่แล้ว

    ☺️

  • @harshpatel1385
    @harshpatel1385 5 ปีที่แล้ว

    the problem was form leetcode.

    • @RachitJain
      @RachitJain  5 ปีที่แล้ว

      I dont know.

    • @harshpatel1385
      @harshpatel1385 5 ปีที่แล้ว

      @@RachitJain Great efforts from your side keep posting video bro.

    • @mgk210
      @mgk210 5 ปีที่แล้ว

      Hey man can u share the link or SS of problem? @harsh Patel

  • @vaibhavsingh3550
    @vaibhavsingh3550 5 ปีที่แล้ว

    First one😁